BEGIN {
	printf("/* generated by makesymbol.awk */\n");
	n = 0;
}

substr($0, 1, 1) ~ "[A-Za-z]" {
	name = $1;
	zoom = $2;
}

substr($0, 1, 1) ~ "[#.]" {
	w = length($0);
	h++;
	for(i = 1; i <= w; i += 8) {
		x = 0;
		if(substr($0, i + 0, 1) == "#")
			x = x + 128;
		if(substr($0, i + 1, 1) == "#")
			x = x + 64;
		if(substr($0, i + 2, 1) == "#")
			x = x + 32;
		if(substr($0, i + 3, 1) == "#")
			x = x + 16;
		if(substr($0, i + 4, 1) == "#")
			x = x + 8;
		if(substr($0, i + 5, 1) == "#")
			x = x + 4;
		if(substr($0, i + 6, 1) == "#")
			x = x + 2;
		if(substr($0, i + 7, 1) == "#")
			x = x + 1;
	
		bit[n] = bit[n] sprintf("0x%02x, ", x);
	}
}

$0 == "" {
	width[n]  = w;
	height[n] = h;
	bits[n]   = b;

	w = 0;
	h = 0;
	n++;
}

END {
	for(i = 0; i < n; i++) {
		printf("static uint8 _%s%s_%02d_bitmap[] = {\n", name, zoom, i);
		printf("\t%s\n", bit[i]);
		printf("};\n");
	}
	printf("static Bitmap bmp%s%s[] = {\n", name, zoom);
	for(i = 0; i < n; i++)
		printf("\t{ %d, %d, _%s%s_%02d_bitmap },\n", width[i], height[i], name, zoom, i);
	printf("};\n");
}
